.code
fscErrPathLen equ -2
fscErrNoMem equ -1
fscDirChange equ 0
fscFileFound equ 1
;; pType     : ENUM
;; pFullPath : LPSZ READONLY
fnFindCallback TYPEDEF PROTO STDCALL pType:DWORD, pFullPath:DWORD

PATH_BUFFER_SIZE equ ((MAX_PATH+15) and -16)

ExtractFileExt proc pszNamePath,pOutBuff
	invoke StrLen,pszNamePath
	mov edx,pszNamePath
	mov cl,'.'
	add edx,eax
	.while eax
		dec eax
		dec edx
		.break .if byte ptr [edx] == cl
	.endw
	invoke StrCpy,pOutBuff,edx
	ret
ExtractFileExt endp

ExtractFileNam proc pszNamePath,pOutBuff
	invoke StrLen,pszNamePath
	mov edx,pszNamePath
	mov cl,'\'
	add edx,eax
	.while eax
		dec eax
		dec edx
		.if byte ptr [edx] == cl
			inc edx
			.break
		.endif
	.endw
	invoke StrCpy,pOutBuff,edx
	mov edx,pOutBuff
	mov ecx,'.'
	.while (byte ptr [edx] != ch) && (byte ptr [edx] != cl) 
		inc edx
		nop
	.endw
	mov [edx],ch
	ret
ExtractFileNam endp

FindFile proc uses ebx esi edi pStartPath:DWORD, pFileFilter:DWORD, pFindCallback:fnFindCallback
	LOCAL hFind:DWORD
	LOCAL sExt1:dword 
	LOCAL sExt2:dword
	LOCAL wfd:WIN32_FIND_DATA 
	; check params & alloc mem
	Invoke StrLen,pStartPath
	mov edi,eax
	Invoke StrLen,pFileFilter
	lea eax,[eax+edi+2]; two #0
	cmp eax,PATH_BUFFER_SIZE
	jae @@ErrPathLen 
	invoke GlobalAlloc,GPTR,PATH_BUFFER_SIZE
	test eax,eax
	jz @@ErrNoMem
	mov esi,eax
	lea eax,[edi+1]; including the #0
	; make *.* filter, backslash checked 
	invoke CopyMemory,esi,pStartPath,eax
	.if byte ptr [esi+edi-1] == '\'; last char '\' ?
		mov dword ptr [esi+edi],'*'
	.elseif word ptr [esi+edi-2] != '*\'
		mov dword ptr [esi+edi],'*\'
	.endif
	invoke FindFirstFile,esi,addr wfd
	mov hFind,eax
	.while sdword ptr eax > 0
		lea edi,wfd.cFileName
		Invoke StrLen,edi
		.if wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY
			movzx edx,word ptr [edi]
			.if ( edx != '.' ) && ( ! ( eax == 2 && edx == '..') )
				Invoke StrLen,esi
				lea eax,[eax+esi-1]
				invoke StrCpy,eax,edi
				invoke pFindCallback,fscDirChange,esi
				invoke FindFile,esi,pFileFilter,pFindCallback; recurse me gently
				invoke StrCpy,esi,pStartPath
				Invoke StrLen,esi
				mov dword ptr [esi+eax],'*\'
			.endif
		.else
			invoke GlobalAlloc,GPTR,PATH_BUFFER_SIZE
			mov sExt1,eax
			invoke GlobalAlloc,GPTR,PATH_BUFFER_SIZE
			mov sExt2,eax
			invoke ExtractFileExt,pFileFilter,sExt1
			invoke ExtractFileExt,edi,sExt2
			invoke StrCmpi,sExt2,sExt1
			.if !eax
				invoke ExtractFileNam,pFileFilter,sExt1
				invoke StrCmpi,edi,pFileFilter
				mov edx,sExt1
				.if !eax || word ptr [edx] == '*' 
					invoke StrLen,esi
					mov ebx,eax
					invoke StrLen,edi
					lea ebx,[ebx+eax+1]
					invoke GlobalAlloc,GPTR,ebx
					mov ebx,eax
					invoke StrCpy,ebx,esi
					invoke StrLen,ebx
					invoke StrCpy,addr [ebx+eax-1],edi
					invoke pFindCallback,fscFileFound,ebx
					invoke GlobalFree,ebx  
				.endif	
			.endif
			invoke GlobalFree,sExt1
			invoke GlobalFree,sExt2
		.endif
		Invoke FindNextFile,hFind,addr wfd
	.endw
	invoke GlobalFree,esi
	invoke FindClose,hFind
	ret

@@ErrPathLen:
	invoke pFindCallback,fscErrPathLen,eax
	ret

@@ErrNoMem:
	invoke pFindCallback,fscErrNoMem,eax
	ret
	
FindFile endp


